package dev.peerat.backend.routes.admins.puzzle;

import java.util.regex.Matcher;

import dev.peerat.backend.model.Puzzle;
import dev.peerat.backend.repository.DatabaseRepository;
import dev.peerat.framework.Context;
import dev.peerat.framework.HttpReader;
import dev.peerat.framework.HttpWriter;
import dev.peerat.framework.Response;
import dev.peerat.framework.Route;
import dev.peerat.framework.utils.json.JsonMap;

public class GetPuzzle implements Response{
	
	private DatabaseRepository repo;
	
	public GetPuzzle(DatabaseRepository repo){
		this.repo = repo;
	}
	
	@Route(path = "^/admin/puzzle/(\\d+)$", needLogin = true)
	public void exec(Matcher matcher, Context context, HttpReader reader, HttpWriter writer) throws Exception{
		Puzzle puzzle = this.repo.getAdminPuzzle(Integer.parseInt(matcher.group(1)));
		JsonMap json = new JsonMap();
		json.set("name", puzzle.getName());
		json.set("content", puzzle.getContent());
		json.set("soluce", new String(puzzle.getSoluce()));
		json.set("score_max", puzzle.getScoreMax());
		
		context.response(200);
		writer.write(json.toString()+"\n");
	}

}
